﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Client
{
	class PClientSocket
	{
		private readonly int BUFF_SIZE = 1024 * 50;
		private Socket sock;
		private IPEndPoint endPoint;

		public PClientSocket(string ip, int port)
		{
			// create socket
			sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
			endPoint = new IPEndPoint(IPAddress.Parse(ip), port);
			sock.Connect(endPoint);
		}

		public void Send(string msg)
		{
			byte[] buff = Encoding.UTF8.GetBytes(msg);
			int sendSize = sock.Send(buff, SocketFlags.None);
		}

		public void Connect()
		{
			// connect end point
			sock.Connect(endPoint);

			string cmd = string.Empty;
			byte[] receiveBuff = new byte[BUFF_SIZE];

			Console.WriteLine("Connected... Press Q to exit.");

			while ((cmd = Console.ReadLine()) != "Q")
			{
				byte[] buff = Encoding.UTF8.GetBytes(cmd);

				// send data
				sock.Send(buff, SocketFlags.None);

				// receive data
				int n = sock.Receive(receiveBuff);

				string data = Encoding.UTF8.GetString(receiveBuff, 0, n);
				Console.WriteLine($"Received: {data}");
			}

			sock.Close();
		}

		public void ContinuousSend()
		{
			byte[] buff = Encoding.UTF8.GetBytes("Hello TCP");

			while (true)
			{
				int sendSize = sock.Send(buff, SocketFlags.None);
				//Console.WriteLine($"send size: {sendSize}");
				
				Thread.Sleep(500);
			}
		}
	}
}
