﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PUtility
{
	public class PFileManager
	{
		public static PFileManager Instance { get; set; } = new PFileManager();

		public string DirPath { get; set; } = Application.StartupPath + @"\Files";
		public string LogDirPath { get; set; } = Application.StartupPath + @"\Logs";

		private void CheckFolder(string dirPath)
		{
			DirectoryInfo directoryInfo = new DirectoryInfo(dirPath);
			if (!directoryInfo.Exists)
				directoryInfo.Create();
		}

		public void SaveFile(byte[] data, string fileName)
		{
			CheckFolder(this.DirPath);

			if (string.IsNullOrEmpty(fileName))
				fileName = Guid.NewGuid().ToString();

			string fileSaveName = PUtil.CheckFileDuplication(this.DirPath, fileName);
			string filePath = Path.Combine(this.DirPath, fileSaveName);
			PUtil.BytesToFile(filePath, data);
		}

		public void WriteLog(string log)
		{
			CheckFolder(this.LogDirPath);

			DateTime now = DateTime.Now;
			string logPath = Path.Combine(this.LogDirPath, $"[{now.ToString("yyyyMMdd")}]log.txt");

			using (FileStream fs = new FileStream(logPath, FileMode.Append, FileAccess.Write, FileShare.ReadWrite))
			{
				using (StreamWriter sw = new StreamWriter(fs, Encoding.UTF8))
				{
					sw.WriteLine($"[{now.ToString("yyyyMMdd HH:mm:ss")}] {log + Environment.NewLine}");
					sw.Flush();
				}
			}

			//File.AppendAllText(logPath, $"[{now.ToString("yyyyMMdd HH:mm:ss")}] {log + Environment.NewLine}");
		}
	}
}
