﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading.Tasks;

namespace Server_Async
{
	class PServerSocket
	{
		private readonly int BUFF_SIZE = 8192;
		private Socket sock;
		private IPEndPoint endPoint;

		private List<Socket> clientSockets;


		public PServerSocket(int port)
		{
			// create socket
			sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
			endPoint = new IPEndPoint(IPAddress.Any, port);
		}

		public async Task Listen()
		{
			clientSockets = new List<Socket>();

			sock.Bind(endPoint);

			sock.Listen(100);

			while (true)
			{
				Socket clientSocket = await Task.Factory.FromAsync(sock.BeginAccept, sock.EndAccept, null);
				clientSockets.Add(clientSocket);

				byte[] buff = new byte[BUFF_SIZE];

				int n = await Task.Factory.FromAsync<int>(
					clientSocket.BeginReceive(buff, 0, buff.Length, SocketFlags.None, null, clientSocket),
					clientSocket.EndReceive);

				if (n > 0)
				{
					string data = Encoding.UTF8.GetString(buff, 0, n);
					Console.WriteLine($"Received: {data}");

					data = "Echo from server " + data;
					buff = Encoding.UTF8.GetBytes(data);
					await Task.Factory.FromAsync(
						clientSocket.BeginSend(buff, 0, buff.Length, SocketFlags.None, null, clientSocket),
						clientSocket.EndSend);
				}

				clientSocket.Close();
			}
		}
	}
}
